/***************************************************************************
                          tempd.h  -  description
                             -------------------
    begin                : Sat Jun 3 2000
    copyright            : (C) 2000 by Joris Struyve
    email                : j.struyve@village.uunet.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

 /* structs */
typedef struct
{
	char code[251];	/* calibration point name    */
	long x_val;		/* X value                   */
	long y_val;		/* Y value                   */
} calibration_point;

typedef struct
{
	char code[21];		/* meter code (name)         */
	int	io_channel;	/* io channel to scan        */
	int	interval;		/* scan interval in seconds  */
	/* y = ax + b */
	float a;			/* regression line parameter */
	float b;			/* regression line parameter */

} meter;


typedef struct
{
	int	io_channel;	/* io channel to scan        */
	int	noof_pulses;	/* noof pulses to scan       */

} scan_request;

typedef struct
{
	int	io_channel;	/* io channel to scan        */
	int	value;		/* pulse length in usecs     */
} scan_response;

/* defines */
#define REQUEST_FIFO     "/dev/rtf0"
#define RESPONSE_FIFO    "/dev/rtf1"
#define REQUEST_FIFO_ID  0
#define RESPONSE_FIFO_ID 1
#define FIFO_SIZE 400

/* global vars */
extern int noof_meters;

/* tempd.c prototypes */
void Signal(int sig);
int InitMeters(meter **meters,char *connectstr);
int ScanMeter(meter *mtr,char* scantime);

/* sensor.c prototypes */
int InitBoard(short lptport,short delay);
int ReadDirectPulseLength(int io_channel,int pulscount);

/* tempd_ora.pc prototypes */
int ConnectToOracle(const char *username,const char *passwd,const char*database,char **ant);
int ConnectToOracleByString(char const *conn,char **ant);
void DisconnectFromOracle(void);
void SqlError(char **error);
int GetMeters(meter **meters,int *noof_meters,char **err);
int GetCalibrationPoints(char *meter,calibration_point **cal_point,int *noof_points,char **err);
int InsertMeterValue(char *code,long raw_value,float cal_value,char* scantime,char **err);
